/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the use of a rowColumn widget.
***************************************************************/

/* rowcolumn.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, rowcol, buttons[10];

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;
    int x;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* resize toplevel */
    ac=0;
    XtSetArg(al[ac],XmNheight,120); ac++;
    XtSetArg(al[ac],XmNwidth,480); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a RowColumn container to hold widgets */
    ac=0;
    XtSetArg(al[ac], XmNpacking, XmPACK_TIGHT); ac++;
    XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
    XtSetArg(al[ac], XmNadjustLast, False); ac++;
    rowcol=XmCreateRowColumn(toplevel,"rowcol",al,ac);
    XtManageChild(rowcol);

    /* create 10 push buttons */
    for (x=0; x<10; x++)
    {
        ac=0;
        XtSetArg(al[ac],XmNlabelString,
            XmStringCreate("I'm a button",char_set)); ac++;
        buttons[x]=XmCreatePushButton(rowcol,"button",al,ac);
        XtManageChild(buttons[x]);
    }

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}

