/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code implements a process-killing application using the
link library and a selection box dialog.
***************************************************************/

/* mkill.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/SelectioB.h>
#include "link.h"

#define    OK    1
#define CANCEL    2

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel,button,dialog;

void dialogCB(w,client_data,call_data)
    Widget w;
    int client_data;
    XmSelectionBoxCallbackStruct *call_data;
/* callback function for the selection box */
{
    char *procstr,s[100];

    switch (client_data)
    {
        case OK:
            XmStringGetLtoR(call_data->value,char_set,&procstr);
            /* extract the process number from the line and
               kill that process number. */
            *(procstr+5)='\0';
            strcpy(s,"kill -9 ");
            strcat(s,procstr);
            system(s);

            XtFree(procstr);
            break;
        case CANCEL:
            break;
    }
    XtUnmanageChild(w);
}

void buttonCB(w,client_data,call_data)
    Widget w;
    int client_data;
    XmAnyCallbackStruct *call_data;
/* callback function for the push to kill button */
{
    Arg al[10];
    int ac;
    struct link_handle l;
    char s[200];
    XmString xs;
    Widget list;

    /* establish a link to ps with the link library, and place
       the strings from it into the selection box. */
    link_open(&l,"ps","-g");
    link_read(&l,s);  /*lose header line*/
    list=XmSelectionBoxGetChild(dialog,XmDIALOG_LIST);
    XmListDeleteAllItems(list);
    while (!link_read(&l,s))
    {
         xs=XmStringCreateLtoR(s,char_set);
         XmListAddItem(list,xs);
         XmStringFree(xs);
    }
    link_close(&l);

    XtManageChild(dialog);
}

void main(argc,argv)
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the "push to kill" button */
    ac=0;
    XtSetArg(al[ac],XmNlabelString, 
        XmStringCreate("Push to kill",char_set)); ac++;
    button=XmCreatePushButton(toplevel,"label",al,ac);
    XtManageChild(button);
    XtAddCallback(button, XmNactivateCallback, buttonCB, NULL);

    /* create the selection box dialog */
    ac = 0;
    XtSetArg(al[ac],XmNautoUnmanage,False); ac++;
    XtSetArg(al[ac],XmNmustMatch,True); ac++;
    XtSetArg(al[ac],XmNselectionLabelString, 
        XmStringCreateLtoR("Pick a process to kill.",char_set)); ac++;
    dialog=XmCreateSelectionDialog(toplevel,"dialog",al,ac);
    XtAddCallback(dialog,XmNokCallback, dialogCB,OK);
    XtAddCallback(dialog,XmNcancelCallback,dialogCB,CANCEL);
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,
        XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,
         XmDIALOG_APPLY_BUTTON));

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
